diff --git a/src/mpi/init/initthread.c b/src/mpi/init/initthread.c
index 35ef62b89e7..71a47e38d31 100644
--- a/src/mpi/init/initthread.c
+++ b/src/mpi/init/initthread.c
@@ -248,6 +248,19 @@ static int thread_cs_init(void)
 
     MPID_THREADPRIV_KEY_CREATE;
 
+    {
+        /*
+         * Trick the Intel compiler into treating MPIR_Per_thread as TLS
+         * See https://github.com/pmodels/mpich/issues/3437
+         */
+        MPIR_Per_thread_t *per_thread = NULL;
+
+        MPID_THREADPRIV_KEY_GET_ADDR(MPIR_ThreadInfo.isThreaded, MPIR_Per_thread_key,
+                                     MPIR_Per_thread, per_thread, &err);
+        MPIR_Assert(err == 0);
+        memset(per_thread->strerrbuf, 0, MPIR_STRERROR_BUF_SIZE);
+    }
+
     MPL_DBG_MSG(MPIR_DBG_INIT, TYPICAL, "Created global mutex and private storage");
     return MPI_SUCCESS;
 }
